//<!---------------------------------------->
//<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
//<!-- DESC       : ctrl de son user      -->
//<!-- VERSION    : 1.1                   -->
//<!-- VERS. DATE : 12.05.2022            -->
//<!-- CREA. DATE : 10.03.2022            -->
//<!---------------------------------------->

$(document).ready(function () {
    //creation classe contrôle
    ctrl = new Ctrl();

    //charger script demande
    $.getScript("javascript/service/serviceHTTP.js", function() {
        console.log("serviceHTTP.js charge !");

        ctrl.getInfos(chargerUserSuccess, chargerUserError);
    });

});

class Ctrl {
    pk = 0;
    
    constructor() {

    }

    getInfos(successCallBack, errorCallBack) {
        //aller chercher les recettes dans la DB
        getRequest(null, successCallBack, errorCallBack, 'userManager.php');
    }

    deconnexion() {
        //se déconnecter du site
        postRequest('action=deconnexion', deconnectionSuccess, deconnectionError, 'userManager.php');
    }

    showImage() {
        var imageUrl = document.getElementById('MYUSER_AVATARPATH_URL').value;
        $('#MYUSER_AVATARPATH_PREVIEW').attr("src", imageUrl);
    }

    saveChanges() {
        //popup pour demander la confirmation pour sauvegarder
        if (window.confirm("êtes vous sûr(e) de vouloir sauvegarder vos changements ?\nL'image qui sera prise est celle affichée actuellement, pas l'url inscrite.")) {
            //si répond oui, proceed.
            var description = $('#MYUSER_DESCRIPTION').val();
            var avatarPath = document.getElementById('MYUSER_AVATARPATH_PREVIEW').src;
            var params = 'pk=' + this.pk + '&description=' + description + '&image=' + avatarPath;
            putRequest(params, SaveChangesSuccess, SaveChangesError, 'userManager.php');
        } //si répond non, rien
    }

    deleteRecipe(pk_recette) {
        //popup pour demander la confirmation pour delete
        if (window.confirm("êtes vous sûr(e) de vouloir supprimer cette recette ?")) {
            //si répond oui, proceed.
            var params = 'pk=' + pk_recette;
            deleteRequest(params, deleteRecipeSuccess, deleteRecipeError, 'recipeManager.php');
        } //si répond non, rien
    }
}


function SaveChangesSuccess(data, text, jqXHR) {
    console.log(data);
    console.log('it worked to save');
    
    //reload direct de la page
    window.location.href = "./MyUser.html";
}

function SaveChangesError(request, status, error) {
    console.log(data);
    console.log('it failed to save');
    
    //reload direct de la page
    window.alert("nous n'avons pas réussi à sauvegarder les changements");
}

//fonction qui ecrit les recettes dans lla partie dediee
function chargerRecettesSuccess(data, text, jqXHR) {
    for (var i = 0; i < Object.keys(data).length; i++) {
        var recette = '<li id="RECETTE_' + data[i]['pk'] + '">'
                    + '<table>'
                    + '<tr>'
                    + '<td>' + data[i]['nom'] + '</td>'
                    + '<td class="MYUSER_RECIPE_BUTTONS_BOX">'
                    + '<ul class="MYUSER_RECIPE_BUTTONS_LIST">'
                    + '<li>'
                    + '<a href="./MyRecipe.html?ID=' + data[i]['pk'] + '">E</a>'
                    + '</li>'
                    + '<li>'
                    + '<a onclick="ctrl.deleteRecipe(' + data[i]['pk'] + ');">x</a>'
                    + '</li>'
                    + '</ul>'
                    + '</td>'
                    + '</tr>'
                    + '</table>'
                    + '</li>';
        $('#MYUSER_RECIPE_LIST').append(recette);
	}

    var finrecettes = '<li>'
                    + '<table>'
                    + '<tr>'
                    + '<td>Nouvelle recette...</td>'
                    + '<td class="MYUSER_RECIPE_ADD_BOX">'
                    + '<a class="MYUSER_RECIPE_ADD_LINK" href="./MyRecipe.html">+</a>'
                    + '</td>'
                    + '</tr>'
                    + '</table>'
                    + '</li>';
    $('#MYUSER_RECIPE_LIST').append(finrecettes);
}

function chargerRecettesError(request, status, error) {
    //alert("Erreur lors de la lecture des recettes: " + error);
    console.log(error);
    console.log(status);

    //dire que l'on a pas réussi à attraper une recette ou alors le user en a pas
    window.alert("Aucune recette trouvée.\nSoit vous n'avez pas de recettes, soit il y a une erreur.");

    //AFFICHER UNE PAGE TEMPORAIRE
    var finrecettes = '<li>'
    + '<table>'
    + '<tr>'
    + '<td>Nouvelle recette...</td>'
    + '<td class="MYUSER_RECIPE_ADD_BOX">'
    + '<a class="MYUSER_RECIPE_ADD_LINK" href="./MyRecipe.html">+</a>'
    + '</td>'
    + '</tr>'
    + '</table>'
    + '</li>';
    $('#MYUSER_RECIPE_LIST').html(finrecettes);
}

function chargerUserSuccess(data, text, jqXHR) {
    var pk_user = data['pk'];
    var username = data['name'];
    var description = data['description'];
    var image = data['avatarpath'];
    var imagealt = "this.src='./image/default_avatar.png';";
    var contenu = '<h1>' + username + '</h1>'
                + '<h2>Description</h2>'
                + '<textarea id="MYUSER_DESCRIPTION" name="userdescription" placeholder="Description ici..." rows="7" >' + description + '</textarea>'
                + '<h2>URL de la photo de profil</h2>'
                + '<table id="MYUSER_AVATARPATH_TABLE">'
                + '<tr>'
                + '<td>'
                + '<input type="text" id="MYUSER_AVATARPATH_URL" name="useravatarpath" placeholder="url de votre avatar..." value="' + image + '">'
                + '</td>'
                + '<td>'
                + '<a onclick="ctrl.showImage();">Afficher</a>'
                + '</td>'
                + '</tr>'
                + '</table>'
                + '<img id="MYUSER_AVATARPATH_PREVIEW" alt="' + pk_user + '" onerror=' + imagealt + ' src="' + image + '"/>'
                + '<div id="MYUSER_REGISTERBUTTON_BOX">'
                + '<a id="MYUSER_REGISTERBUTTON_LINK" onclick="ctrl.saveChanges();">enregistrer</a>'
                + '</div>'
                + '<h2>Mes recettes</h2>'
                + '<ul id="MYUSER_RECIPE_LIST">'
                + '</ul>';
    $('#MYUSER').html(contenu);
    
    ctrl.pk = pk_user;
    //afficher la partie user de la barre de navigation
    var contenu =
'<ul>'+
'   <li id="NAV_LOGO_BOX">'+
'       <a href="./" id="NAV_LOGO_LINK">ReciΠ</a>'+
'   </li>'+
'   <li id="NAV_USER_IMAGE_BOX">'+
'       <img id="NAV_USER_IMAGE_IMG" alt="⬤" src="' + image + '">'+
'   </li>'+
'   <li id="NAV_USER_NAME_BOX">'+
'       <a id="NAV_USERNAME_TEXT">' + username + '</a>'+
'   </li>'+
'   <li id="NAV_DELOG_BOX">'+
'       <a id="NAV_DELOG_LINK" onclick="ctrl.deconnexion();">   ❌</a>'+
'   </li>'+
'   <li class="NAV_PAGELINK_BOX">'+
'       <a class="NAV_PAGELINK_LINK" href="./MyUser.html">MyUser</a>'+
'   </li>'+
'   <li class="NAV_PAGELINK_BOX">'+
'       <a class="NAV_PAGELINK_LINK" href="./Recettes.html">Recettes</a>'+
'   </li>'+
'</ul>';

    $('#NAV').html(contenu);

    //puis aller chercher les recettes
    getRequest('pk_user='+pk_user, chargerRecettesSuccess, chargerRecettesError, 'recipeManager.php');
}
function chargerUserError(request, status, error) {
    console.log(error);
    console.log(status);
    window.location.href = "./Connexion.html";
}
function deconnectionSuccess(data, text, jqXHR) {
    //afficher la partie user de la barre de navigation
    console.log(data);
    console.log('it worked');
    window.location.href = "./Recettes.html";
}
function deconnectionError(request, status, error) {
    console.log(status);
    console.log(error);
    console.log('it FAILED');
    alert("UNE ERREUR CATASTROPHIQUE S'EST PASSEE");
    window.location.href = "./Recettes.html";
}
function deleteRecipeSuccess(data, text, jqXHR) {
    console.log(data);
    console.log('it worked to delete');
    
    //popup pour annoncer la réussite
    window.alert("Nous avons réussi à supprimer la recette");

    //SUPPRIMER LA RECETTE (donc replacer toutes les recettes retournées)
    $('#MYUSER_RECIPE_LIST').html("");
    chargerRecettesSuccess(data, null, null);
}
function deleteRecipeError(request, status, error) {
    console.log(status);
    console.log(error);
    console.log('it FAILED to delete');
    
    //AFFICHER POPUP D'ERREUR
    alert("Nous n'avons pas réussi à supprimer la recette");
    
    //RELOAD LA PAGE
    window.location.href = "./MyUser.html";
}
