//<!--------------------------------------------->
//<!-- AUTHOR     : DIAS MADEIRA LUCA          -->
//<!-- DESC       : service d'accès au serveur -->
//<!-- VERSION    : 1.1                        -->
//<!-- VERS. DATE : 12.05.2022                 -->
//<!-- CREA. DATE : 25.02.2022                 -->
//<!--------------------------------------------->

var BASE_URL = "../SERVEUR/ctrl/";

/**
 * Fonction permettant de récupérer des infos depuis la DB
 * @param {type} Fonction de callback lors du retour avec succès de l'appel.
 * @param {type} Fonction de callback en cas d'erreur.
 */
function getRequest(datas, successCallback, errorCallback, url) {
  $.ajax({
    type: "GET",
    dataType: "JSON",
    url: BASE_URL + url,
    data: datas,
    success: successCallback,
    error: errorCallback
  });
}

/**
 * Fonction permettant d'ajouter un message.
 * @param datas. valeurs à envoyer
 * @param successCallback Fonction de callback lors du retour avec succès de l'appel.
 * @param errorCallback Fonction de callback en cas d'erreur.
 */
function postRequest(datas, successCallback, errorCallback, url) {
  $.ajax({
    type: "POST",
    url: BASE_URL + url,
    data: datas,
    success: successCallback,
    error: errorCallback
  });
}


/**
 * Fonction permettant d'ajouter un message.
 * @param datas. valeurs à envoyer
 * @param successCallback Fonction de callback lors du retour avec succès de l'appel.
 * @param errorCallback Fonction de callback en cas d'erreur.
 */
 function putRequest(datas, successCallback, errorCallback, url) {
  $.ajax({
    type: "PUT",
    url: BASE_URL + url,
    data: datas,
    success: successCallback,
    error: errorCallback
  });
}

/**
 * Fonction permettant de supprimer une info de la db
 * @param datas. valeurs à envoyer
 * @param successCallback Fonction de callback lors du retour avec succès de l'appel.
 * @param errorCallback Fonction de callback en cas d'erreur.
 */
 function deleteRequest(datas, successCallback, errorCallback, url) {
  $.ajax({
    type: "DELETE",
    url: BASE_URL + url,
    data: datas,
    success: successCallback,
    error: errorCallback
  });
}
