<?php 
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : managerdb des recettes-->
<!-- VERSION    : 1.2                   -->
<!-- VERS. DATE : 10.03.2022            -->
<!-- CREA. DATE : 18.02.2022            -->
<!---------------------------------------->
*/
	include_once('../wrk/ConnexionDB.php');
    include_once('../bean/Ingredient.php');
    include_once('../bean/Step.php');
    include_once('../bean/Recipe.php');
    include_once('../bean/User.php');
        
	class recipeDBManager
	{
		public function addIngredient($name) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedname = htmlspecialchars($name);

            //00. sécurisation SQL des paramètres reçu.
            $cname = addslashes($httpcleanedname);

            //1. vérifier si un ingrédient du même nom n'existe pas déjà

            //1a. si oui, ne pas en ajouter un, et retourner la pk_ingredient de l'ingrédient existant

            //1b0. si non, en créer un avec le nom

            //1b1. puis aller chercher sa pk_ingredient et la retourner

        }
        public function addRecipe($fk_user, $name, $description, $image) {
            $answer = false;

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedfk_user = htmlspecialchars($fk_user);
            $httpcleanedname = htmlspecialchars($name);
            $httpcleaneddescription = htmlspecialchars($description);
            $httpcleanedimage = htmlspecialchars($image);

            //00. sécurisation SQL des paramètres reçu.
            $cfk_user = addslashes($httpcleanedfk_user);
            $cname = addslashes($httpcleanedname);
            $cdescription = addslashes($httpcleaneddescription);
            $cimage = addslashes($httpcleanedimage);

            //1. ajouter la recette dans la base de données
            $params = array('fkuser' => $fk_user, 'name' => $name, 'description' => $description, 'image' => $image);
            $query = ConnexionDB::getInstance()->executeQuery(
                'INSERT INTO 151_ldm_db_recipe.t_recipe (FK_User, Name, Description, Image)
                 VALUES ( :fkuser , :name , :description , :image );
                ', $params
            );

            //2. aller chercher la recette dans la db et retourner sa pk_recipe
            $answer = ConnexionDB::getInstance()->getLastId('151_ldm_db_recipe.t_recipe');

            return $answer;
        }
        public function addRecipeIngredient($fpk_recipe, $fpk_ingredient, $quantity) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedfpk_recipe = htmlspecialchars($fpk_recipe);
            $httpcleanedfpk_ingredient = htmlspecialchars($fpk_ingredient);
            $httpcleanedquantity = htmlspecialchars($quantity);

            //00. sécurisation SQL des paramètres reçu.
            $cfpk_recipe = addslashes($httpcleanedfpk_recipe);
            $cfpk_ingredient = addslashes($httpcleanedfpk_ingredient);
            $cquantity = addslashes($httpcleanedquantity);

            //1. vérifier si un lien entre la recette et l'ingrédient n'existe pas déjà


            //1a. si oui, ne pas en ajouter un, et simplement mettre à jour la quantité

            //1b. si non, en ajouter un

            //retourner true si c'est bien passé.

        }
        public function addStep($fk_recipe, $description, $priority) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedfk_recipe = htmlspecialchars($fk_recipe);
            $httpcleanedpriority = htmlspecialchars($priority);
            $httpcleaneddescription = htmlspecialchars($description);

            //00. sécurisation SQL des paramètres reçu.
            $cfk_recipe = addslashes($httpcleanedfk_recipe);
            $cpriority = addslashes($httpcleanedpriority);
            $cdescription = addslashes($httpcleaneddescription);

            //1. ajouter l'étape dans la db

            //2. aller chercher la pk de l'étape et la retourner

        }
        public function deleteIngredient($pk_ingredient) {

            //0. sécurisation SQL des paramètres reçu.
            $cpk_ingredient = addslashes($pk_ingredient);

            //1. vérifier si l'ingrédient existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, supprimer l'ingrédient

            //1b1. retourner true ou false selon si la suppression a marché

        }
        public function deleteRecipe($pk_recipe) {

            //0. sécurisation SQL des paramètres reçu.
            $cpk_recipe = addslashes($pk_recipe);

            //1. vérifier si la recette existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, aller chercher toutes les étapes de la recette

            //1b1. supprimer toutes les étapes de la recette

            //1b2. chercher les liens recette-ingrédient de la recette

            //1b3. supprimer ces liens

            //1b4. supprimer la recette

            //1b5. si tout a marché, retourenr true, sinon false

        }
        public function deleteRecipeIngredientLink($fpk_recipe, $fpk_ingredient) {

            //0. sécurisation SQL des paramètres reçu.
            $cfpk_recipe = addslashes($fpk_recipe);
            $cfpk_ingredient = addslashes($fpk_ingredient);

            //1. vérifier si le lien existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, supprimer le lien

            //1b1. retourner true ou false selon si la suppression a marché

        }
        public function deleteStep($pk_step) {

            //0. sécurisation SQL des paramètres reçu.
            $cpk_step = addslashes($pk_step);

            //1. vérifier si l'étape existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, supprimer l'étape

            //1b1. retourner true ou false selon si la suppression a marché

        }
        public function getAllRecipes() {

            $answer = false;

            //1. chercher dans la db si les recettes liés aux ingrédients
            $recettesSansEtapes = array();
            $count = 0;
            $query = ConnexionDB::getInstance()->selectQuery(
            'SELECT recette.PK_Recipe pk_recette, recette.FK_User fk_user, recette.Name name, recette.Description description, recette.Image image, TR.Quantity quantity, ingredient.PK_Ingredient pk_ingredient, ingredient.Name ingredient FROM 151_ldm_db_recipe.t_recipe recette 
             INNER JOIN 151_ldm_db_recipe.tr_recipe_ingredient TR 
             ON TR.FPK_Recipe = recette.PK_Recipe
             INNER JOIN 151_ldm_db_recipe.t_ingredient ingredient
             ON TR.FPK_Ingredient = ingredient.PK_Ingredient;', null
            );

            if($query) {
            
            
                foreach($query as $data){
                    //si la pk_recipe existe déjà dans la liste de recette, ajouter l'ingrédient
                    $recipeAlreadyInList = false;
                    $whichRecipe;
                    foreach($recettesSansEtapes as $recette) {
                        if($recette->getPK_Recipe() === $data['pk_recette']) {
                            $recipeAlreadyInList = true;
                            $whichRecipe = $recette;
                            break;
                        }
                    }
                    if($recipeAlreadyInList) {
                        $ingredients = $whichRecipe->getIngredients();
                        $newIngredient = new Ingredient($data['pk_ingredient'], $data['ingredient'], $data['quantity']);
                        array_push($ingredients, $newIngredient);
                        $whichRecipe->setIngredients($ingredients);
                    }
                    //sinon en créer un nouveau
                    else {
                        $uneRecette = new Recipe(
                            $data['pk_recette'],
                            $data['name'],
                            $data['image'],
                            $data['description'],
                            $data['fk_user'],
                            "steps",
                            array(new Ingredient($data['pk_ingredient'], $data['ingredient'], $data['quantity']))
                            
                        );
                        $recettesSansEtapes[$count++] = $uneRecette;
                    }
                }	
                
                //2. retourner la réponse formatée en JSON
                $answer = json_encode($recettesSansEtapes);
            }

            return $answer;

        }
        public function getElementsOfRecipe($pk_recipe) {

            //0. sécurisation SQL des paramètres reçu.
            $cpk_recipe = addslashes($pk_recipe);

            //1. chercher la recette dans la db si elle existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, récupérer les éléments

            //1b1. formater la réponse en XML OU JSON

            //1b2. retourner la réponse formatée, ou false si il y a une erreur

        }
        public function getElement($name_ingredient) {

            //0. sécurisation SQL des paramètres reçu.
            $cname_ingredient = addslashes($name_ingredient);

            //1. chercher l'ingrédient dans la db si elle existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, récupérer l'éléments

            //1b1. formater la réponse en XML OU JSON

            //1b2. retourner la réponse formatée, ou false si il y a une erreur

        }
        public function getRecipe($pk_recipe) {
            $answer = false;

            //0. sécurisation SQL des paramètres reçu.
            $cpk_recipe = addslashes($pk_recipe);

            //1. chercher dans la db la recette seule, accompagnée de son user.

            $firstQuery = ConnexionDB::getInstance()->selectQuery(
            'SELECT recette.PK_Recipe pk_recette, recette.FK_User fk_user, recette.Name name, recette.Description description, recette.Image image, user.AvatarPath userimage, user.Name username FROM 151_ldm_db_recipe.t_recipe recette 
            INNER JOIN 151_ldm_db_recipe.t_user user
            ON user.PK_User = recette.FK_User
            WHERE recette.PK_Recipe = :pk_recette;', array('pk_recette' => $cpk_recipe)
            );

            $data1 = $firstQuery;

            //2. chercher dans la db les ingrédients (et quantité) de la recette
            $secondQuery = ConnexionDB::getInstance()->selectQuery(
            'SELECT ingredient.Name ingredient, ingredient.PK_Ingredient pk_ingredient, TR.Quantity quantity FROM 151_ldm_db_recipe.t_ingredient ingredient
            INNER JOIN 151_ldm_db_recipe.tr_recipe_ingredient TR
            ON ingredient.PK_Ingredient = TR.FPK_Ingredient
            WHERE TR.FPK_Recipe = :pk_recette;', array('pk_recette' => $cpk_recipe)
            );

            $data2 = $secondQuery;

            //3. chercher dans la db les étapes de la recette
            $thirdQuery = ConnexionDB::getInstance()->SelectQuery(
            'SELECT step.PK_Step pk_step, step.FK_Recipe fk_recipe, step.Priority priority, step.Description stepdescription FROM 151_ldm_db_recipe.t_step step
            WHERE step.FK_Recipe = :pk_recette;', array('pk_recette' => $cpk_recipe)
            );

            $data3 = $thirdQuery;

            //check si les recherche ont foirés
            if ($data1 && $data2 && $data3) {
                if( !empty($data1) && !empty($data2) && !empty($data3) ) {

                    //4. grouper les ingrédients en un array
                    $ingredcount = 0;
                    $ingredients = array();
                    foreach($data2 as $data) {
                        $ingredients[$ingredcount++] = new Ingredient($data['pk_ingredient'], $data['ingredient'], $data['quantity']);
                    }

                    //5. grouper les étapes en un array
                    $stepcount = 0;
                    $steps = array();
                    foreach($data3 as $data) {
                        $steps[$data['priority']] = new Step($data['pk_step'], $data['priority'], $data['stepdescription'], $data['fk_recipe']);
                    }

                    
                    $user;
                    $recipe;
                    foreach($data1 as $data) {

                        //6. utiliser les informations du user pour en créer un bean
                        $user = new User($data['fk_user'], null, null, $data['username'], null, $data['userimage']);

                        //7. créer un bean recette
                        $recipe = new Recipe(
                            $data['pk_recette'],
                            $data['name'],
                            $data['image'],
                            $data['description'],
                            $user,
                            $steps,
                            $ingredients
                        );

                        //8. le transformer en JSON
                        $answer = json_encode($recipe);
                    }
                } else {
                    $answer = 'invalid ID';
                }
            }

            return $answer;

            
        }
        public function getRecipeOfUser($pk_user) {
            

            $answer = false;

            //1. chercher dans la db si les recettes liés aux ingrédients
            $recettesSansEtapes = array();
            $count = 0;
            $query = ConnexionDB::getInstance()->selectQuery(
            'SELECT recette.PK_Recipe pk_recette, recette.FK_User fk_user, recette.Name name, recette.Description description, recette.Image image, TR.Quantity quantity, ingredient.PK_Ingredient pk_ingredient, ingredient.Name ingredient FROM 151_ldm_db_recipe.t_recipe recette 
             INNER JOIN 151_ldm_db_recipe.tr_recipe_ingredient TR 
             ON TR.FPK_Recipe = recette.PK_Recipe
             INNER JOIN 151_ldm_db_recipe.t_ingredient ingredient
             ON TR.FPK_Ingredient = ingredient.PK_Ingredient
             WHERE fk_user = :pkuser ;', array('pkuser' => $pk_user)
            );

            if($query) {
              if(!empty($query)) {
            
                foreach($query as $data){
                    //si la pk_recipe existe déjà dans la liste de recette, ajouter l'ingrédient
                    $recipeAlreadyInList = false;
                    $whichRecipe;
                    foreach($recettesSansEtapes as $recette) {
                        if($recette->getPK_Recipe() === $data['pk_recette']) {
                            $recipeAlreadyInList = true;
                            $whichRecipe = $recette;
                            break;
                        }
                    }
                    if($recipeAlreadyInList) {
                        $ingredients = $whichRecipe->getIngredients();
                        $newIngredient = new Ingredient($data['pk_ingredient'], $data['ingredient'], $data['quantity']);
                        array_push($ingredients, $newIngredient);
                        $whichRecipe->setIngredients($ingredients);
                    }
                    //sinon en créer un nouveau
                    else {
                        $uneRecette = new Recipe(
                            $data['pk_recette'],
                            $data['name'],
                            $data['image'],
                            $data['description'],
                            $data['fk_user'],
                            "steps",
                            array(new Ingredient($data['pk_ingredient'], $data['ingredient'], $data['quantity']))
                            
                        );
                        $recettesSansEtapes[$count++] = $uneRecette;
                    }
                }	
                
                //2. retourner la réponse formatée en JSON
                $answer = json_encode($recettesSansEtapes);
              } else {
                $answer = 'invalid ID';
              }
            }

            return $answer;
        }
        public function getStepOfRecipe($pk_recipe) {

            //0. sécurisation SQL des paramètres reçu.
            $cpk_recipe = addslashes($pk_recipe);

            //1. chercher la recette dans la db si elle existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, récupérer les étapes

            //1b1. formater la réponse en XML OU JSON

            //1b2. retourner la réponse formatée, ou false si il y a une erreur

        }
        public function updateIngredient($pk_ingredient, $name) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedpk_ingredient = htmlspecialchars($pk_ingredient);
            $httpcleanedname = htmlspecialchars($name);

            //00. sécurisation SQL des paramètres reçu.
            $cpk_ingredient = addslashes($httpcleanedpk_ingredient);
            $cname = addslashes($httpcleanedname);

            //1. vérifier si, en cherchant dans la db avec la pk, que l'ingrédient existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, mettre à jour la recette dans la db

            //1b1. retourner true ou false selon si la mise à jour a marchée

        }
        public function updateRecipe($pk_recipe, $fk_user, $image, $description, $name) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedpk_recipe = htmlspecialchars($pk_recipe);
            $httpcleanedfk_user = htmlspecialchars($fk_user);
            $httpcleanedname = htmlspecialchars($name);
            $httpcleaneddescription = htmlspecialchars($description);
            $httpcleanedimage = htmlspecialchars($image);

            //00. sécurisation SQL des paramètres reçu.
            $cpk_recipe = addslashes($httpcleanedpk_recipe);
            $cfk_user = addslashes($httpcleanedfk_user);
            $cname = addslashes($httpcleanedname);
            $cdescription = addslashes($httpcleaneddescription);
            $cimage = addslashes($httpcleanedimage);

            //1. vérifier si, en cherchant dans la db avec la pk et la fk, que la recette existe
            //   (la fk pour empêcher des modifications frauduleuse)

            
            //1a. si non, retourner 'does not exist'

            //1b0. si oui, mettre à jour dans la db la recette

            //1b1. retourner true ou false selon si la mise à jour a marché

        }
        public function updateRecipeIngredientLink($fpk_recipe, $fpk_ingredient, $quantity) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedfpk_recipe = htmlspecialchars($fpk_recipe);
            $httpcleanedfpk_ingredient = htmlspecialchars($fpk_ingredient);
            $httpcleanedquantity = htmlspecialchars($quantity);

            //00. sécurisation SQL des paramètres reçu.
            $cfpk_recipe = addslashes($httpcleanedfpk_recipe);
            $cfpk_ingredient = addslashes($httpcleanedfpk_ingredient);
            $cquantity = addslashes($httpcleanedquantity);

            //1. vérifier si, en cherchant dans la db avec les fpk, que le lien existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, mettre à jour le lien dans la db

            //1b1. retourner true ou false selon si la mise à jour a marché

        }
        public function updateStep($pk_step, $priority, $description) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedpk_step = htmlspecialchars($pk_step);
            $httpcleanedpriority = htmlspecialchars($priority);
            $httpcleaneddescription = htmlspecialchars($description);

            //00. sécurisation SQL des paramètres reçu.
            $cpk_step = addslashes($httpcleanedpk_step);
            $cpriority = addslashes($httpcleanedpriority);
            $cdescription = addslashes($httpcleaneddescription);

            //1. vérifier si, en cherchant dans la db avec la pk, que l'étape existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, mettre à jour l'étape dans la db

            //1b1. retourner true ou false selon si la mise à jour a marché

        }
	}
?>