<?php 

/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : manager db des users  -->
<!-- VERSION    : 1.0                   -->
<!-- VERS. DATE : 10.03.2022            -->
<!-- CREA. DATE : 18.02.2022            -->
<!---------------------------------------->
*/
	include_once('../wrk/connexionDB.php');
    include_once('../bean/User.php');
        
	class userDBManager
	{
		public function addUser($name, $email, $password) {

            $answer = false;

            //0. sécurisation HTTP des paramètres reçu.
            $cname = htmlspecialchars($name);
            $cemail = htmlspecialchars($email);
            $cpassword = htmlspecialchars($password);


            //1. vérifier si un user du même email ou username n'existe pas déjà
            $checkingQuery = ConnexionDB::getInstance()->selectQuery(
               'SELECT count(*) 
                FROM 151_ldm_db_recipe.t_user user
                WHERE ((user.Email = :useremail) OR (user.Name = :username));',
                array('username' => $cname, 'useremail' => $cemail)
            );

            
            if ($checkingQuery) {
                if($checkingQuery[0][0] == '0') {
                    
                    //1b0. si non, en créer un avec le nom, l'email et le password
                    $defaultavatarpath = 'https://i.pinimg.com/originals/60/99/f3/6099f305983371dadaceae99f5c905bf.png';
                    $passwordhashed = password_hash($cpassword, PASSWORD_DEFAULT);

                    $params = array('name' => $cname, 'email' => $cemail, 'password' => $passwordhashed, 'image' => $defaultavatarpath);
                    $query = ConnexionDB::getInstance()->executeQuery(
                        '
                         INSERT INTO 151_ldm_db_recipe.t_user (Name, Email, Password, AvatarPath)
                         VALUES ( :name , :email , :password , :image );
                         
                        ', $params
                    );


                    //si requête réussie
                    if($query == 1) {
                        //1b1. puis aller chercher sa pk_user 
                        $answer = ConnexionDB::getInstance()-> getLastId('151_ldm_db_recipe.t_user');
                    }
                } else {
                    //1a. si oui, ne pas en ajouter un, et retourner 'email or username already taken'
                    $answer = 'email or username already taken';
                }
            }
            
            return $answer;
        }
        public function getUser($pk_user) {
            $answer = false;

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedpk_user = htmlspecialchars($pk_user);

            //00. sécurisation SQL des paramètres reçu.
            $cpk_user = addslashes($httpcleanedpk_user);

            //1. chercher le user dans la db 
            $query = ConnexionDB::getInstance()->selectQuery(
               'SELECT user.PK_User pk, user.Name name, user.Description description, user.AvatarPath image
                FROM 151_ldm_db_recipe.t_user user
                WHERE user.PK_User = :pkuser ;', array('pkuser' => $cpk_user)
            );

            if($query) {
                if(!empty($query)) {

                    //créer un Bean du user
                    $user;
                    foreach($query as $data) {
                        $user = new User(
                            $data['pk'],
                            null,
                            $data['description'],
                            $data['name'],
                            null,
                            $data['image']
                        );
                    }

                    //le formater en JSON
                    $answer = json_encode($user);

                } else {
                    $answer = 'invalid ID';
                }
            }

            return $answer;
        
        }
        public function getUserOfRecipe($pk_recipe) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedpk_recipe = htmlspecialchars($pk_recipe);

            //00. sécurisation SQL des paramètres reçu.
            $cpk_recipe = addslashes($httpcleanedpk_recipe);

            //1. chercher le user dans la db 

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, récupérer les recettes

            //1b1. formater la réponse en XML OU JSON

            //1b2. retourner la réponse formatée, ou false si il y a une erreur

        }
        public function updateUser($pk_user, $description, $avatarPath) {

            //0. sécurisation HTTP des paramètres reçu.
            $httpcleanedpk_user = htmlspecialchars($pk_user);
            $httpcleaneddescription = htmlspecialchars($description);
            $httpcleanedavatarPath = htmlspecialchars($avatarPath);

            //00. sécurisation SQL des paramètres reçu.
            $cpk_user = addslashes($httpcleanedpk_user);
            $cdescription = addslashes($httpcleaneddescription);
            $cavatarPath = addslashes($httpcleanedavatarPath);

            //1. vérifier si, en cherchant dans la db avec la pk, que le user existe

            //1a. si non, retourner 'does not exist'

            //1b0. si oui, mettre à jour le user dans la db

            //1b1. retourner true ou false selon si la mise à jour a marchée
            
        }
	}
?>